<template>
  <div id="quotaManagement" class="container">
    <b-row>
      <div class="col-sm-2"></div>
      <div class="col-sm-8">
        <coscine-headline :headline="$t('headline')" />
        <coscine-form-group>
          <b-row>
            <b-col>
              {{ $t("projectLabel") }}
              <b-form-select
                v-model="selectedProjectId"
                :options="projectsSelectOptions"
                value-field="id"
                text-field="name"
                @change="changeProject()"
                :disabled="true"
              >
                <template #first>
                  <b-form-select-option value="" disabled>{{
                    $t("emptyProjectSelect")
                  }}</b-form-select-option>
                </template>
              </b-form-select>
            </b-col>
            <b-col>
              {{ $t("resourceTypeLabel") }}
              <b-form-select
                v-model="selectedResourceTypeId"
                :options="resourceTypesSelectOptions"
                value-field="id"
                text-field="name"
                @change="changeResourceType()"
                :disabled="resourceTypesSelectOptions.length === 1"
              >
                <template #first>
                  <b-form-select-option value="" disabled>{{
                    $t("emptyResourceTypeSelect")
                  }}</b-form-select-option>
                </template>
              </b-form-select>
            </b-col>
          </b-row>
        </coscine-form-group>
        <coscine-form-group
          class="projectQuotaSlider"
          :label="
            selectedResourceType.allocated +
            $t('rangeText1').toString() +
            selectedResourceType.available +
            $t('rangeText2').toString()
          "
          :disabled="
            resourceTypeInformationHashmap[selectedResourceType.id] &&
            !resourceTypeInformationHashmap[selectedResourceType.id]
              .isQuotaAdjustable
          "
        >
          {{ selectedResourceType.used }}{{ $t("gb") }}
          <b-form-input
            v-model="selectedResourceType.allocated"
            type="range"
            :min="selectedResourceType.used"
            :max="selectedResourceType.available"
            @change="changeProjectQuota()"
          ></b-form-input>
          {{ selectedResourceType.available }}{{ $t("gb") }}
        </coscine-form-group>
        <b-row>
          <b-col>
            <b-button
              class="float-right"
              :href="$t('moreHelpLink')"
              target="_blank"
            >
              {{ $t("moreHelp") }}
            </b-button>
          </b-col>
        </b-row>
        <div class="h-divider"></div>
        <coscine-headline :headline="$t('resources')" />
        <coscine-form-group>
          <b-table
            :fields="tableFields"
            :items="resources"
            :busy="loadingData && selectedResourceTypeId !== ''"
            show-empty
            :empty-text="
              selectedResourceTypeId !== ''
                ? $t('emptyTableText')
                : $t('noResourceTypeChoosen')
            "
          >
            <template v-slot:head(name)>
              <span>{{ $t("resource") }}</span>
            </template>
            <template v-slot:head(allocated)>
              <span>{{ $t("allocated") }}</span>
            </template>
            <template v-slot:head(used)>
              <span>{{ $t("used") }}</span>
            </template>
            <template v-slot:head(adjust)>
              <span>{{ $t("adjustQuota") }}</span>
            </template>
            <template v-slot:cell(allocated)="data">
              {{ data.item.allocated }}{{ $t("gb") }}
            </template>
            <template v-slot:cell(used)="data">
              {{ parseInt((data.item.used / data.item.allocated) * 100 + "") }}%
            </template>
            <template v-slot:cell(adjust)="data">
              {{ data.item.used }}{{ $t("gb") }}
              <b-form-input
                v-model="data.item.allocated"
                type="range"
                :min="data.item.used"
                :max="data.item.maxAvailable"
                @change="changeResourceQuota(data.item)"
              ></b-form-input>
              {{ data.item.maxAvailable }}{{ $t("gb") }}
            </template>
            <template #table-busy>
              <div class="text-center text-danger my-2">
                <b-spinner class="align-middle"></b-spinner>
                <strong>{{ $t("loading") }}</strong>
              </div>
            </template>
          </b-table>
        </coscine-form-group>
      </div>
      <div class="col-sm-2"></div>
    </b-row>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import { ProjectApi, ResourceTypeApi, QuotaApi } from "@coscine/api-connection";
import { LanguageUtil, GuidUtil } from "@coscine/app-util";
import { CoscineFormGroup, CoscineHeadline } from "@coscine/component-library";
import "@coscine/component-library/dist/index.css";

interface Resource {
  id: string;
  name: string;
  used: any;
  allocated: any;
  maxAvailable: any;
}

export default Vue.extend({
  name: "quotaManagement",
  components: {
    CoscineFormGroup,
    CoscineHeadline,
  },
  data() {
    return {
      projectInformationHashmap: {} as any,
      resourceTypeHashmap: {} as any,
      resourceTypeInformationHashmap: {} as any,

      selectedProjectId: "",
      selectedResourceTypeId: "",

      projectsSelectOptions: [] as Record<string, unknown>[],
      resourceTypesSelectOptions: [] as Record<string, unknown>[],

      selectedResourceType: {
        id: "",
        name: "",
        used: 0,
        allocated: 25,
        available: 100,
      },

      resources: [] as Resource[],

      tableFields: [
        { key: "name", sortable: true },
        { key: "allocated", sortable: true },
        "used",
        "adjust",
      ],
      loadingData: true,
    };
  },
  created() {
    this.selectedProjectId = GuidUtil.getProjectId();
    ProjectApi.getProjects(
      (response: any) => {
        response.data.forEach((element: any) => {
          this.projectsSelectOptions.push({
            id: element.id,
            name: element.displayName,
          });
          this.projectInformationHashmap[element.id] = element;
        });
      },
      () => {
        this.showConnectionErrorToast();
      }
    );
    ResourceTypeApi.getResourceTypes(
      (response: any) => {
        response.data.forEach((element: any) => {
          this.resourceTypeInformationHashmap[element.id] = element;
        });
      },
      () => {
        this.showConnectionErrorToast();
      }
    );
    this.changeProject();
  },
  methods: {
    showConnectionErrorToast() {
      this.makeToast(
        this.$t("connectionErrorTitle").toString(),
        this.$t("connectionErrorBody").toString(),
        true
      );
    },
    changeProject() {
      ProjectApi.getQuotas(
        this.selectedProjectId,
        (response: any) => {
          this.resourceTypeHashmap = [];
          this.resourceTypesSelectOptions = [];
          response.data.forEach((element: any) => {
            // if resource type has a size
            // and is enabled or already exists
            if (
              this.resourceTypeInformationHashmap[element.id] !== undefined &&
              this.resourceTypeInformationHashmap[element.id]
                .isQuotaAvailable &&
              this.resourceTypeInformationHashmap[element.id].isEnabled
            ) {
              this.resourceTypesSelectOptions.push({
                id: element.id,
                name: this.$t("ResourceTypes." + element.name + ".displayName"),
              });
              this.resourceTypeHashmap[element.id] = {
                id: element.id,
                name: element.name,
                used: element.used,
                allocated: element.allocated,
                available: element.maximum,
              };
              if (element.id === this.selectedResourceTypeId) {
                this.changeResourceType(true);
              } else if (this.selectedResourceTypeId === "") {
                this.selectedResourceTypeId = element.id;
                this.changeResourceType();
              }
            }
          });
          this.resourceTypesSelectOptions.sort((a: any, b: any) =>
            a.name < b.name ? -1 : a.name > b.name ? 1 : 0
          );
        },
        () => {
          this.loadingData = false;
          this.showConnectionErrorToast();
        }
      );
    },
    changeResourceType(changedProject = false) {
      if (this.selectedResourceTypeId !== "" && changedProject === false) {
        this.resourceTypeHashmap[this.selectedResourceType.id] =
          this.selectedResourceType;
      }
      if (
        this.selectedResourceTypeId === "" &&
        this.resourceTypeHashmap.length === 0
      ) {
        this.selectedResourceTypeId = (
          this.resourceTypesSelectOptions[0] as any
        ).id;
      }
      this.selectedResourceType =
        this.resourceTypeHashmap[this.selectedResourceTypeId];

      QuotaApi.getResourceQuotas(
        this.selectedProjectId,
        this.selectedResourceTypeId,
        (response2: any) => {
          this.resources = [];
          response2.data.forEach((element: any) => {
            this.resources.push({
              id: element.id,
              name: element.name,
              used: element.used,
              allocated: element.allocated,
              maxAvailable: element.allocated,
            });
            this.calcMaxFreeSpace();
          });
          this.loadingData = false;
        },
        () => {
          this.loadingData = false;
          this.showConnectionErrorToast();
        }
      );
    },
    changeProjectQuota() {
      this.selectedResourceType.allocated = parseInt(
        this.selectedResourceType.allocated + "",
        10
      );
      this.calcMaxFreeSpace();
      ProjectApi.setQuota(
        this.selectedProjectId,
        this.selectedResourceTypeId,
        {
          id: this.selectedResourceTypeId,
          allocated: this.selectedResourceType.allocated,
        },
        () => {
          this.makeToast(
            this.$t("resourceTypeQuotaChangedSuccessTitle").toString(),
            this.$t("resourceTypeQuotaChangedSuccessBody", {
              ProjectName:
                this.projectInformationHashmap[this.selectedProjectId]
                  .displayname,
              AmountInGB: this.selectedResourceType.allocated,
            }).toString()
          );
        },
        () => {
          this.makeToast(
            this.$t("resourceTypeQuotaChangedFailureTitle").toString(),
            this.$t("resourceTypeQuotaChangedFailureBody").toString(),
            true
          );
        }
      );
    },
    changeResourceQuota(data: any) {
      data.allocated = parseInt(data.allocated, 10);
      this.calcMaxFreeSpace();
      QuotaApi.setResourceQuota(
        data.id,
        { id: data.id, allocated: data.allocated },
        () => {
          this.makeToast(
            this.$t("resourceQuotaChangedSuccessTitle").toString(),
            this.$t("resourceQuotaChangedSuccessBody", {
              ResourceName: data.name,
              AmountInGB: data.allocated,
            }).toString()
          );
        },
        () => {
          this.makeToast(
            this.$t("resourceQuotaChangedFailureTitle").toString(),
            this.$t("resourceQuotaChangedFailureBody").toString(),
            true
          );
        }
      );
    },
    makeToast(givenTitle = "Title", text = "Message", error = false) {
      if (error) {
        this.$bvToast.toast(text, {
          title: givenTitle,
          noAutoHide: true,
          variant: "warning",
          toaster: "b-toaster-bottom-right",
        });
      } else {
        this.$bvToast.toast(text, {
          title: givenTitle,
          toaster: "b-toaster-bottom-right",
          noCloseButton: true,
        });
      }
    },
    calcMaxFreeSpace: function () {
      let totalAllocatedSpace = 0;
      for (const resource of this.resources) {
        totalAllocatedSpace += parseInt(resource.allocated + "", 10);
      }
      let maxFreeSpace =
        parseInt(this.selectedResourceType.allocated + "", 10) -
        totalAllocatedSpace;
      this.selectedResourceType.used = totalAllocatedSpace;
      for (const resource of this.resources) {
        resource.maxAvailable =
          parseInt(resource.allocated + "", 10) + maxFreeSpace;
      }
    },
  },
});
</script>

<style scoped>
.list-group {
  width: 20%;
}
input[type="range"] {
  width: calc(100% - 8em);
}
.h-divider {
  margin-top: 5px;
  margin-bottom: 10px;
  height: 1px;
  width: 100%;
  border-top: 1px solid #bebbbb;
}
</style>
<style>
.b-table-empty-row {
  background-color: #f5f5f5;
}
.projectQuotaSlider .col {
  padding-top: calc(0.375rem + 1px);
  padding-bottom: calc(0.375rem + 1px);
}
</style>
